commit c554aeb5f329036b127c6d20d2a9f19d266f7e90
Author: Patrick Palka <ppalka@redhat.com>
Date:   Wed Aug 26 21:52:58 2020 -0400

    libstdc++: elements_view's sentinel and iterator not comparable [LWG 3406]
    
    This implements the proposed resolution for LWG 3406, and adds a
    testcase for the example from P1994R1.
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ranges (elements_view::begin): Adjust constraints.
            (elements_view::end): Likewise.
            (elements_view::_Sentinel::operator==): Templatize to take both
            _Iterator<true> and _Iterator<false>.
            (elements_view::_Sentinel::operator-): Likewise.
            * testsuite/std/ranges/adaptors/elements.cc: Add testcase for
            the example from P1994R1.
            * testsuite/std/ranges/adaptors/lwg3406.cc: New test.
    
    (cherry picked from commit 4be16d1c1cfa6d151d2853ce509c1a797189c9ad)

diff --git a/libstdc++-v3/include/std/ranges b/libstdc++-v3/include/std/ranges
index 87ed798b7a9..41f35d1d108 100644
--- a/libstdc++-v3/include/std/ranges
+++ b/libstdc++-v3/include/std/ranges
@@ -3356,15 +3356,15 @@ namespace views
       { return _Iterator<false>(ranges::begin(_M_base)); }
 
       constexpr auto
-      begin() const requires __detail::__simple_view<_Vp>
+      begin() const requires range<const _Vp>
       { return _Iterator<true>(ranges::begin(_M_base)); }
 
       constexpr auto
-      end()
+      end() requires (!__detail::__simple_view<_Vp> && !common_range<_Vp>)
       { return _Sentinel<false>{ranges::end(_M_base)}; }
 
       constexpr auto
-      end() requires common_range<_Vp>
+      end() requires (!__detail::__simple_view<_Vp> && common_range<_Vp>)
       { return _Iterator<false>{ranges::end(_M_base)}; }
 
       constexpr auto
@@ -3570,19 +3570,26 @@ namespace views
 	  base() const
 	  { return _M_end; }
 
-	  friend constexpr bool
-	  operator==(const _Iterator<_Const>& __x, const _Sentinel& __y)
-	  { return __y._M_equal(__x); }
-
-	  friend constexpr range_difference_t<_Base>
-	  operator-(const _Iterator<_Const>& __x, const _Sentinel& __y)
-	    requires sized_sentinel_for<sentinel_t<_Base>, iterator_t<_Base>>
-	  { return __x._M_current - __y._M_end; }
-
-	  friend constexpr range_difference_t<_Base>
-	  operator-(const _Sentinel& __x, const _Iterator<_Const>& __y)
-	    requires sized_sentinel_for<sentinel_t<_Base>, iterator_t<_Base>>
-	  { return __x._M_end - __y._M_current; }
+	  template<bool _Const2>
+	    requires sentinel_for<sentinel_t<_Base>,
+		       iterator_t<__detail::__maybe_const_t<_Const2, _Vp>>>
+	    friend constexpr bool
+	    operator==(const _Iterator<_Const2>& __x, const _Sentinel& __y)
+	    { return __y._M_equal(__x); }
+
+	  template<bool _Const2,
+		   typename _Base2 = __detail::__maybe_const_t<_Const2, _Vp>>
+	    requires sized_sentinel_for<sentinel_t<_Base>, iterator_t<_Base2>>
+	    friend constexpr range_difference_t<_Base2>
+	    operator-(const _Iterator<_Const2>& __x, const _Sentinel& __y)
+	    { return __x._M_current - __y._M_end; }
+
+	  template<bool _Const2,
+		   typename _Base2 = __detail::__maybe_const_t<_Const2, _Vp>>
+	    requires sized_sentinel_for<sentinel_t<_Base>, iterator_t<_Base2>>
+	    friend constexpr range_difference_t<_Base>
+	    operator-(const _Sentinel& __x, const _Iterator<_Const2>& __y)
+	    { return __x._M_end - __y._M_current; }
 
 	  friend _Sentinel<!_Const>;
 	};
diff --git a/libstdc++-v3/testsuite/std/ranges/adaptors/elements.cc b/libstdc++-v3/testsuite/std/ranges/adaptors/elements.cc
index d846c4cf33e..3026adf4f28 100644
--- a/libstdc++-v3/testsuite/std/ranges/adaptors/elements.cc
+++ b/libstdc++-v3/testsuite/std/ranges/adaptors/elements.cc
@@ -45,8 +45,30 @@ test01()
   VERIFY( ranges::equal(v1, x | views::values) );
 }
 
+struct S
+{
+  friend bool
+  operator==(std::input_iterator auto const& i, S)
+  { return std::get<1>(*i) == 0; }
+};
+
+void
+test02()
+{
+  // This verifies that P1994R1 (and LWG3406) is implemented.
+  std::pair<std::pair<char, int>, long> x[]
+    = {{{1,2},3l}, {{1,0},2l}, {{1,2},0l}};
+  ranges::subrange r{ranges::begin(x), S{}};
+
+  auto v = r | views::keys;
+  VERIFY( ranges::equal(v, (std::pair<char, int>[]){{1,2},{1,0}}) );
+  ranges::subrange v2{ranges::begin(v), S{}};
+  VERIFY( ranges::equal(v2, (std::pair<char, int>[]){{1,2}}) );
+}
+
 int
 main()
 {
   test01();
+  test02();
 }
diff --git a/libstdc++-v3/testsuite/std/ranges/adaptors/lwg3406.cc b/libstdc++-v3/testsuite/std/ranges/adaptors/lwg3406.cc
new file mode 100644
index 00000000000..72190cc2e8a
--- /dev/null
+++ b/libstdc++-v3/testsuite/std/ranges/adaptors/lwg3406.cc
@@ -0,0 +1,40 @@
+// Copyright (C) 2020 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++2a" }
+// { dg-do compile { target c++2a } }
+
+#include <ranges>
+
+namespace ranges = std::ranges;
+namespace views = std::views;
+
+void
+test01()
+{
+  std::tuple<int, int> x[] = {{0,0}};
+  auto v = x | views::elements<0>;
+  bool b = ranges::cbegin(v) == ranges::end(v);
+}
+
+void
+test02()
+{
+  std::tuple x = {0, 1};
+  auto v = views::single(x) | views::elements<0>;
+  auto i = ranges::cbegin(v);
+}

